// MultiVoicePack Loader 1.04 by Retsam 2002-8-20
// Extened Voice Locator also by Retsam
// Allows ~wv for standard player voice commands
// Allows ~wA for any audio in the /Audio directory
//
// CustomVoice.cs ver 2.2  4-15-01 - written by Govt.Cheese[D6]
// 
// This file makes the Voicepack support and Custum Voice Pack autoload
// at the end of all other script inits. This is done because the 
// functions supercede some of the existing tribes2 ones.
// To use this functionality see the accompying Make_Your_Own File.

//--------DO NOT EDIT BELOW THIS LINE----------
// DO NOT EDIT THIS FILE!!

//Init the global table and the counter to 0 at script run
$VoicePackCount = 0; //no packs registered
$voicePackTable[0] = ""; //The global table of Voices Built
$voicePackChangedActive = 0; //Gets set to 1 if we change in the gui
$VoicePackInit = 0; //Detects if the list has been built yet

deactivatePackage(CustomVoicePackage);
package CustomVoicePackage {

function DispatchLaunchMode() 
{
	// Create our Gui object before things get run
	VoicePackMenuCreate();
	parent::DispatchLaunchMode();
}

// This function will create the gui objects, independent of a hierarchy, that we
// want to add to the GameGui. 
function VoicePackMenuCreate()
{
	if(strstr($pref::video::resolution, "640")!=	-1) {
		echo("Running at 640 mode...");
		%pos1 = "9 40";
		%pos2 = "125 31";
	} else {
		%pos1 = "264 12";
		%pos2 = "380 3";
		}
	new GuiTextCtrl(VoicePackText) {
		profile = "ShellTextRightProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = %pos1;
		extent = "115 22";
		minExtent = "8 8";
		visible = "1";
		helpTag = "0";
		text = "MVP Loader v1.04:";
		maxLength = "255";
		};
	new ShellPopupMenu(VoicePackPopup) {
		profile = "ShellPopupProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = %pos2;
		extent = "150 38";
		minExtent = "49 36";
		visible = "1";
		helpTag = "0";
		text = "Select Voice 1";
		maxLength = "30";
		maxPopupHeight = "200";
		buttonBitmap = "gui/shll_pulldown";
		rolloverBarBitmap = "gui/shll_pulldownbar_rol";
		selectedBarBitmap = "gui/shll_pulldownbar_act";
		noButtonStyle = "0";
		};
//The trick to using them without redoing the whole GameGui.cs file is the find the 
// gui object the parents that place that you want to put them and then gets its name
// and do itsname.add(yourobj) . This will create a new object that is a child to them
// and place it on the page automagically! IF you need to install or do things use the 
// parents properties to do them.
	GM_WarriorPane.add(VoicePackText);
	GM_WarriorPane.add(VoicePackPopup);
}

//This function is the parent to our gui objects and we activate our stuff when the
//onActivate gets called, don't forget to parent::onActivate at the end or everything
//goes to hell.
function GM_WarriorPane::onActivate( %this )
{
	VoicePackPopup.clear();
//	echo("Starting VoicePack Menu Build...Have "@$VoicePackCount@" Voice Packs Registered");

//	Cleanup prefs in case a voicepack was removed

	%i2=0;
	while($pref::Audio::VoicePack[%i2] !$= "") {
		%i2found=-1;
		for(%i=0; %i < $VoicePackCount; %i++) {
//			echo("Looking for: " @ $pref::Audio::VoicePack[%i2] @ " and found: " @ $voicePackTable[%i]);
			if($pref::Audio::VoicePack[%i2] $= $voicePackTable[%i]) {
//				echo("Found: " @ $pref::Audio::VoicePack[%i2]);
				%i2found=%i2;
			}
//			else {
//				echo("** NOT found: " @ $pref::Audio::VoicePack[%i2]);
//			}

			
		}
		// if no match then delete entry %i2
		if(%i2found==-1) {
			echo("Removing " @ $pref::Audio::VoicePack[%i2] @ " from voicepack prefs");
			// Compress $prefs list
			%i3=%i2;
			while($pref::Audio::VoicePack[%i3] !$= "") {
				$pref::Audio::VoicePack[%i3] = $pref::Audio::VoicePack[%i3+1];
				%i3++;
			}
			%i2--;   // go back one because this one is now deleted.

		}
		%i2++;
	}

//

	for(%i=0; %i < $VoicePackCount; %i++) {

		%i2=0;
		%i2found=-1;
		while($pref::Audio::VoicePack[%i2] !$= "") {
			if($pref::Audio::VoicePack[%i2] $= $voicePackTable[%i]) {
				%i2found=%i2;}
			%i2++;
		}
		
//		if ($pref::Audio::VoicePack[%i] != $voicePackTable[%i])
//		{
//			$pref::Audio::VoicePack[%i] = $voicePackTable[%i];
//			$pref::Audio::VoicePackEnabled[%i] = 0;
//		}

		if(%i2found!=-1)
		{ 
			VoicePackPopup.add( " " @ $voicePackTable[%i],%i);
//			echo("Adding "@$voicePackTable[%i]@" to the list of VoicePacks installed");
		}
		else
		{
			VoicePackPopup.add( $voicePackTable[%i],%i);
//			echo("Adding "@$voicePackTable[%i]@" to the list of VoicePacks available");
		}
		
	}
	// Need to check and see if defaultVoicePack exists, if not, set it to,
	//   otherwise, if they don't click on the pack name, nothing will load.
	if($pref::Audio::defaultVoicePack $="")
		$pref::Audio::defaultVoicePack = 0;
//	VoicePackPopup.setSelected($pref::Audio::defaultVoicePack); //Sets the active
	VoicePackPopup.setText("--VoicePacks--"); //Sets the active
	//element in a drop down list.
	parent::onActivate(%this);//For a multiple down function like set1::sub1 you just
	//use the last listed on the parent.
}

function VoicePackPopup::onAdd( %this )
{
	//this is here to keep the compiler from complaing
}

//function that gets called when a drop down menu item is clicked.
function VoicePackPopup::onSelect(%this, %id, %text)
{
	$voicePackChangedActive=1; //We changed an option here, need to rebuild menu.
	$pref::Audio::defaultVoicePack=%id; //Reset the global thing

	%i2=0;
	%i2found=-1;
	while($pref::Audio::VoicePack[%i2] !$= "") {
		if($pref::Audio::VoicePack[%i2] $= $voicePackTable[%id]) {
			%i2found=%i2; break;}
		%i2++;
	}
	if(%i2found==-1) {
		$pref::Audio::VoicePack[%i2] = $voicePackTable[%id];
//		echo("Adding: " @ %i2 @ ": " @ $voicePackTable[%id]);
	}
	else {
//		$pref::Audio::VoicePack[%i2found] = "";
//		echo("Removing: " @ %i2found @ ": " @ $voicePackTable[%id]);
		// Clean up $prefs list
		%i2=%i2found;
		while($pref::Audio::VoicePack[%i2] !$= "") {
			$pref::Audio::VoicePack[%i2] = $pref::Audio::VoicePack[%i2+1];
			%i2++;
		}
	}
	
	GM_WarriorPane::onActivate();
	
	//echo("Pack changed... Active Pack:"@$pref::Audio::defaultVoicePack@" Text: "@%text);
}

//This function actaully loads the callers script to put things on the voice
//menu. It uses the id given as the pack preface.
function VoicePackActivate()
{
 //If we have been in a game or done this several times, we need to clear the global
 //chat menu, this done with activate and the default voiceBinds.cs file
	echo("Starting VoicePack Build...");
	if($voicePackChangedActive==1) {
		echo("Changed selection, rebuilding base menu.");
		activateChatMenu("scripts/voiceBinds.cs");
		$VoicePackInit = 0;
		$voicePackChangedActive=0;
	}
	if($VoicePackInit == 0) {
		$VoicePackInit = 1;

// Always load TM voicepack first
//		if($voicePackTable[$pref::Audio::defaultVoicePack] != "TM") {
//		if(strstr($voicePackTable[$pref::Audio::defaultVoicePack], "TM")!=0) {
//			%scriptname = "scripts/" @ "TM" @ "VoicePack.cs";
//			echo("Pack Selected to Exec: TM");
//			exec(%scriptname);
//		}
		
//
		%i2=0;
		while($pref::Audio::VoicePack[%i2] !$= "") {
			%scriptname = "scripts/" @ $pref::Audio::VoicePack[%i2] @ "VoicePack.cs";
			echo("Pack Selected to Exec: "@%scriptname);
			exec(%scriptname);
			%i2++;
		}
	}
}
//Redone function to load the chat menu
function StartHostedGame()
{
	VoicePackActivate();
	parent::StartHostedGame();
}

function JoinGame(%address)
{
	VoicePackActivate();
	parent::JoinGame(%address);
}

//This function is called by the user/customvoicepack and will register the name
// and increment the number of total packs.
function VoicePackRegisterName(%name)
{
	$voicePackTable[$voicePackCount] = %name;
	$VoicePackCount++;
	echo("Voice Pack Registered: "@ $voicePackTable[$voicePackCount-1]);
	echo("Total Voice Packs Now: "@ $VoicePackCount); 
}

//implement later.
//function testChatCommand( %command )
//{
//	if ( $pref::Player::Count > 0 )
//    		%voiceSet = getField( $pref::Player[$pref::Player::Current], 3 );
//	else
//		%voiceSet = "Male1";
//	ChatCommandTestBtn.setActive( false );
//	if(
//		%wav = "voice/" @ %voiceSet @ "/" @ $ChatTable[%command].audioFile @ ".wav";   
//}

function issueChatCmd( %menu, %index )
{
	// We need to pull the message from the list that was created at the beggining.
	// This is done with the method below, it pulls out the entire string including
	// the voice name with its delimeter
	%command = %menu.command[%index];
	%cmdCode = getWord( %command, 0 );
	%cmdId = getSubStr( %cmdCode, 1, strlen( %command ) - 1 );
	%cmdString = getWord( %command, 1 );
	%chatItem = $ChatTable[%cmdId];
	if(%chatItem.defaultKeys !$= "")
		%message = %chatItem.text @ " \c0[" @ %chatItem.defaultKeys @ "]~w" @ %chatItem.audioFile; //construct the full message
	else
		%message = %chatItem.text @ "~w" @ %chatItem.audioFile; //construct the full message

	// At this point, we check if it is a local sound by looking for the K at the
	// beggining of the filename - this signals our delimeter. ~w is the default 
	// delim for a voice message and we add a K to that so it fools the system into
	// working. But, if we find a custom voice here, we need to use a different method
	// to send to the server and other clients than the default commandToServer(cannedChat,)
	// if cannedChat is sent, the server will auth against its list of voices and reget any 
	// that we send with non normal Bindnames.
	if ((strstr(%message, "~wK") !=-1) || (strstr(%message, "~wV") !=-1) || (strstr(%message, "~wA") !=-1))
		if ( %chatItem.teamOnly ) {
			commandToServer('teamMessageSent', %message, false);
			cancelChatMenu(); //Close chat menu 
		} else {
			commandToServer('messageSent', %message, false);
			cancelChatMenu(); //Close chat menu
		}
	else
		parent::issueChatCmd(%menu, %index);
	// Otherwise send it via the normal method of cannedChat, which auths with the server
	// to make sure that voice sent exists on the server - This BAD! 
} //End of issueChatCmd()


function clientCmdChatMessage(%sender, %voice, %pitch, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10)
{
	%message = detag( %msgString ); $MaxMessageWavLength = 20000;
//	echo(%voice);
	if( (%message $= "" ) || isClientChatMuted(%sender) )
		return;
	%wavStart = strstr(%message,"~w");
	if ( %wavStart == -1 )
		addMessageHudLine(%message);
	else
		if(strstr(%message, "~wK") !=-1) {
//		   	echo("using custom voice");
			%voice = "custom"; //Assign our base directory here.
			%wav = getSubStr(%message, %wavStart + 3, 1000); //Move the name three spaces for our delim
			%wavFile = "voice/" @ %voice @ "/" @ %wav @ ".wav";
			if (%pitch < 0.5 || %pitch > 2.0)
				%pitch = 1.0;
			%wavLengthMS = alxGetWaveLen(%wavFile) * %pitch;
			if ( $ClientChatHandle[%sender] != 0 )
				alxStop( $ClientChatHandle[%sender] );
			$ClientChatHandle[%sender] = alxCreateSource( AudioChat, %wavFile );
			if (%pitch != 1.0)
				alxSourcef($ClientChatHandle[%sender], "AL_PITCH", %pitch);
			alxPlay( $ClientChatHandle[%sender] );
			%message = getSubStr(%message, 0, %wavStart);
			addMessageHudLine(%message);
		// New command to use default voice
		} else if(strstr(%message, "~wV") !=-1) {
//		   	echo("trying to use default voice");
//   			echo(%sender.voice);
//   			echo(%sender.voicetag);
			%voice = detag(%voice);
		
			// Make FLUXVOICE COMPATIBLE
			if(isPackage(fluxVoice))
			{
//				%weight = 3;
//				%pitch = 1.0 + ((%pitch-1)*%weight);
//				echo("fluxvoice installed");
				%pitch = adjustPitch(%pitch);

			}
			//

			%wav = getSubStr(%message, %wavStart + 3, 1000); //Move the name three spaces for our delim
			%wavFile = "voice/" @ %voice @ "/" @ %wav @ ".wav";
			if (%pitch < 0.5 || %pitch > 2.0)
				%pitch = 1.0;
			%wavLengthMS = alxGetWaveLen(%wavFile) * %pitch;
			if ( $ClientChatHandle[%sender] != 0 )
				alxStop( $ClientChatHandle[%sender] );
			$ClientChatHandle[%sender] = alxCreateSource( AudioChat, %wavFile );
			if (%pitch != 1.0)
				alxSourcef($ClientChatHandle[%sender], "AL_PITCH", %pitch);
			alxPlay( $ClientChatHandle[%sender] );
			%message = getSubStr(%message, 0, %wavStart);
			addMessageHudLine(%message);

		} else if(strstr(%message, "~wA") !=-1) {
			%voice = ""; //Assign our base directory here.
			%wav = getSubStr(%message, %wavStart + 3, 1000); //Move the name three spaces for our delim
			%wavFile = %wav @ ".wav";
			if (%pitch < 0.5 || %pitch > 2.0)
				%pitch = 1.0;
			%wavLengthMS = alxGetWaveLen(%wavFile) * %pitch;
			if ( $ClientChatHandle[%sender] != 0 )
				alxStop( $ClientChatHandle[%sender] );
			$ClientChatHandle[%sender] = alxCreateSource( AudioChat, %wavFile );
			if (%pitch != 1.0)
				alxSourcef($ClientChatHandle[%sender], "AL_PITCH", %pitch);
			alxPlay( $ClientChatHandle[%sender] );
			%message = getSubStr(%message, 0, %wavStart);
			addMessageHudLine(%message);

		} else
//		   	echo("bypassing all voice");
		   	parent::clientCmdChatMessage(%sender, %voice, %pitch, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10);
			// Call back using the parent process to handle it if we don't have custom sound.
}

};
activatePackage(CustomVoicePackage);


